org.apache.lucene.search.join

## Class ToParentBlockJoinCollector

- java.lang.Object
- - org.apache.lucene.search.join.ToParentBlockJoinCollector

- All Implemented Interfaces:
    Collector

      public class ToParentBlockJoinCollector
      extends Object
      implements Collector

  Collects parent document hits for a Query containing one more more BlockJoinQuery clauses, sorted by the specified parent Sort. Note that this cannot perform arbitrary joins; rather, it requires that all joined documents are indexed as a doc block (using `IndexWriter.addDocuments(java.lang.Iterable<? extends java.lang.Iterable<? extends org.apache.lucene.index.IndexableField>>)` or `IndexWriter.updateDocuments(org.apache.lucene.index.Term, java.lang.Iterable<? extends java.lang.Iterable<? extends org.apache.lucene.index.IndexableField>>)`). Ie, the join is computed at index time.

  This collector MUST be used with `ToParentBlockJoinIndexSearcher`, in order to work correctly.

  The parent Sort must only use fields from the parent documents; sorting by field in the child documents is not supported.

  You should only use this collector if one or more of the clauses in the query is a `ToParentBlockJoinQuery`. This collector will find those query clauses and record the matching child documents for the top scoring parent documents.

  Multiple joins (star join) and nested joins and a mix of the two are allowed, as long as in all cases the documents corresponding to a single row of each joined parent table were indexed as a doc block.

  For the simple star join you can retrieve the `TopGroups` instance containing each `ToParentBlockJoinQuery`'s matching child documents for the top parent groups, using `getTopGroups(org.apache.lucene.search.join.ToParentBlockJoinQuery, org.apache.lucene.search.Sort, int, int, int, boolean)`. Ie, a single query, which will contain two or more `ToParentBlockJoinQuery`'s as clauses representing the star join, can then retrieve two or more `TopGroups` instances.

  For nested joins, the query will run correctly (ie, match the right parent and child documents), however, because TopGroups is currently unable to support nesting (each group is not able to hold another TopGroups), you are only able to retrieve the TopGroups of the first join. The TopGroups of the nested joins will not be correct. See `org.apache.lucene.search.join` for a code sample.

  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ToParentBlockJoinCollector(Sort sort, int numParentHits, boolean trackScores, boolean trackMaxScore)` Creates a ToParentBlockJoinCollector.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `LeafCollector` | `getLeafCollector(LeafReaderContext context)`
    `float` | `getMaxScore()` Returns the highest score across all collected parent hits, as long as `trackMaxScores=true` was passed `on construction`.
    `TopGroups<Integer>` | `getTopGroups(ToParentBlockJoinQuery query, Sort withinGroupSort, int offset, int maxDocsPerGroup, int withinGroupOffset, boolean fillSortFields)` Returns the TopGroups for the specified BlockJoinQuery.
    `TopGroups<Integer>` | `getTopGroupsWithAllChildDocs(ToParentBlockJoinQuery query, Sort withinGroupSort, int offset, int withinGroupOffset, boolean fillSortFields)` Returns the TopGroups for the specified BlockJoinQuery.
    `boolean` | `needsScores()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ToParentBlockJoinCollector

          public ToParentBlockJoinCollector(Sort sort,
                                    int numParentHits,
                                    boolean trackScores,
                                    boolean trackMaxScore)
                                     throws IOException

      Creates a ToParentBlockJoinCollector. The provided sort must not be null. If you pass true trackScores, all ToParentBlockQuery instances must not use ScoreMode.None.
      Throws:
        `IOException`

  - ### Method Detail

    - #### getLeafCollector

          public LeafCollector getLeafCollector(LeafReaderContext context)
                                         throws IOException

      Specified by:
        `getLeafCollector` in interface `Collector`
      Throws:
        `IOException`

    - #### getTopGroups

          public TopGroups<Integer> getTopGroups(ToParentBlockJoinQuery query,
                                        Sort withinGroupSort,
                                        int offset,
                                        int maxDocsPerGroup,
                                        int withinGroupOffset,
                                        boolean fillSortFields)
                                          throws IOException

      Returns the TopGroups for the specified BlockJoinQuery. The groupValue of each GroupDocs will be the parent docID for that group. The number of documents within each group is calculated as minimum of `maxDocsPerGroup` and number of matched child documents for that group. Returns null if no groups matched.
      Parameters:
        `query` - Search query
        `withinGroupSort` - Sort criteria within groups
        `offset` - Parent docs offset
        `maxDocsPerGroup` - Upper bound of documents per group number
        `withinGroupOffset` - Offset within each group of child docs
        `fillSortFields` - Specifies whether to add sort fields or not
      Returns:
        TopGroups for specified query
      Throws:
        `IOException` - if there is a low-level I/O error

    - #### getTopGroupsWithAllChildDocs

          public TopGroups<Integer> getTopGroupsWithAllChildDocs(ToParentBlockJoinQuery query,
                                                        Sort withinGroupSort,
                                                        int offset,
                                                        int withinGroupOffset,
                                                        boolean fillSortFields)
                                                          throws IOException

      Returns the TopGroups for the specified BlockJoinQuery. The groupValue of each GroupDocs will be the parent docID for that group. The number of documents within each group equals to the total number of matched child documents for that group. Returns null if no groups matched.
      Parameters:
        `query` - Search query
        `withinGroupSort` - Sort criteria within groups
        `offset` - Parent docs offset
        `withinGroupOffset` - Offset within each group of child docs
        `fillSortFields` - Specifies whether to add sort fields or not
      Returns:
        TopGroups for specified query
      Throws:
        `IOException` - if there is a low-level I/O error

    - #### getMaxScore

          public float getMaxScore()

      Returns the highest score across all collected parent hits, as long as `trackMaxScores=true` was passed `on construction`. Else, this returns `Float.NaN`

    - #### needsScores

          public boolean needsScores()

      Specified by:
        `needsScores` in interface `Collector`

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.